#include "derivative.h" /* include peripheral declarations */

 void MCG_PEE_20M(void){
  
  /* Configure MCG to run in PEE Mode */
  /* 20MHz bus clock from a 4MHz external crystal */
  
  /* set up external oscillator */
  MCGC2 = 0x26; /* RANGE = 1; HGO = 0; ERCLKEN=1; EREFS = 1; BDIV = 00 (/1); */
   
  while (!MCGSC_OSCINIT){}/* wait for oscillator to initialize */
  
  /* Configure MCGC3 to access the proper RDIV values */
  MCGC3 = 0x10; /* DIV32 = 1; */
    
  /* Select Clock Mode and Reference Divider */
  MCGC1 = 0x90; /* CLKS = 10; RDIV = 2 (/4, /128 with DIV32=1); IREFS = 0; */

  while (MCGSC_IREFST){} /* wait for Reference Status bit to update */
  
  /* Wait for clock status bits to update */
  while (MCGSC_CLKST != 0b10){}        
  
  /* Configure MCGC3 to select PLL and VDIV */
  MCGC3 = 0x5A; /* PLLS =1; DIV32 = 1; VDIV = 1010 (x40) */
  
  while (!MCGSC_PLLST){} /* wait for PLL status bit to update */
  
  while (!MCGSC_LOCK){} /* Wait for LOCK bit to set */

  /* Now running PBE Mode */
  
  /* Transition into PEE */
  MCGC1 = 0x10; /* CLKS = 00; RDIV = 2 (/4 with PLLS=1); IREFS = 0; */

  /* Wait for clock status bits to update */
  while (MCGSC_CLKST != 0b11){};           

  /* Now running PEE Mode */
 } //end of MCG_PEE_20M(void) 